<?php

namespace App\Http\Requests\Admin;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class RoomRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = ['super_admin', 'admin'];
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('rooms'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=
        [
            'room_id'=>[
                'required',
                'numeric',
                Rule::unique('rooms')->ignore($this->room? $this->room->id : 0, 'id')
            ],
            // 'start_count'=>[
            //     'required',
            //     'numeric'
            // ],
            // 'end_count'=>[
            //     'required',
            //     'numeric',
            //     'gte:start_count'
            // ],
            'cost'=>[
                'required',
                'numeric',
            ],
            'status_min'=>[
                'required',
                'in:true,false'
            ],
            'min_count' => [
                'required',
                // 'nullable',
                'numeric',
                // 'required_if:status_min,==,true'
            ],
            'max_count' => [
                'required',
                'numeric',
                'gte:min_count'
            ],
            'external_image'=>[
                'required'
            ],
            'internal_image'=>[
                'sometimes'
            ],
        ];
        foreach (languages() as $lang) {
            $lang_rules=[
                'name_'.$lang->local=>[
                    'required',
                    'max:60'
                ],
                'description_'.$lang->local=> 'sometimes',
            ];
            $rules= array_merge($rules, $lang_rules);
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $attributes=
            [
                'room_id'=>__('rooms.room_id'),
                'start_count'=>__('rooms.start_count'),
                'end_count'=>__('rooms.end_count'),
                'cost'=>__('rooms.cost'),
                'status_min'=>__('rooms.status_min'),
                'min_count'=>__('rooms.min_count'),
                'max_count'=>__('rooms.max_count'),
                'external_image'=>__('rooms.external_image'),
                'internal_image'=>__('rooms.internal_image'),
            ];
        foreach (languages() as $lang) {
            $lang_attributes=[
                'name_'.$lang->local => __('rooms.name').' '.$lang->local,
                'description_'.$lang->local => __('rooms.description').' '.$lang->local,
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
